searchNodes=[{"doc":"Official SDK for interacting with Knock. Example usage As a module The recommended way to configure Knock is as a module in your application. Doing so will allow you to customize the options via configuration in your app. # lib/my_app/knock.ex defmodule MyApp.Knock do use Knock , otp_app : :my_app end # config/runtime.exs config :my_app , MyApp.KnockClient , api_key : System . get_env ( &quot;KNOCK_API_KEY&quot; ) In your application you can now execute commands on your configured Knock instance. client = MyApp.Knock . client ( ) { :ok , user } = Knock.Users . get_user ( client , &quot;user_1&quot; ) Invoking directly Optionally you can forgo implementing your own Knock module and create client instances manually: client = Knock.Client . new ( api_key : &quot;sk_test_12345&quot; ) Customizing options Out of the box the client will specify Tesla and Jason as the HTTP adapter and JSON client, respectively. However, you can customize this at will: config :my_app , Knock , adapter : Tesla.Adapter.Finch , json_client : JSX You can read more about the availble adapters in the Tesla documentation","ref":"Knock.html","title":"Knock","type":"module"},{"doc":"Issues a notify call, triggering a workflow with the given key.","ref":"Knock.html#notify/3","title":"Knock.notify/3","type":"function"},{"doc":"Api client for interacting with Knock","ref":"Knock.Api.html","title":"Knock.Api","type":"module"},{"doc":"Executes a delete request against the Knock api.","ref":"Knock.Api.html#delete/3","title":"Knock.Api.delete/3","type":"function"},{"doc":"Executes a get request against the Knock api.","ref":"Knock.Api.html#get/3","title":"Knock.Api.get/3","type":"function"},{"doc":"Returns the current version for the library","ref":"Knock.Api.html#library_version/0","title":"Knock.Api.library_version/0","type":"function"},{"doc":"Executes a post request against the Knock api.","ref":"Knock.Api.html#post/4","title":"Knock.Api.post/4","type":"function"},{"doc":"Executes a put request against the Knock api","ref":"Knock.Api.html#put/4","title":"Knock.Api.put/4","type":"function"},{"doc":"Defines available options to pass to an API function","ref":"Knock.Api.html#t:options/0","title":"Knock.Api.options/0","type":"type"},{"doc":"Describes a response from calling an API function","ref":"Knock.Api.html#t:response/0","title":"Knock.Api.response/0","type":"type"},{"doc":"Sets up a configurable client that can interface with the Knock API. Expects at least an API key to be provided. Example usage # Setup a client instance directly client = Knock.Client . new ( api_key : &quot;sk_test_12345&quot; )","ref":"Knock.Client.html","title":"Knock.Client","type":"module"},{"doc":"Creates a new client struct with the provided options. The options provided must at least contain an API secret key, which can be obtained in the Knock dashboard.","ref":"Knock.Client.html#new/1","title":"Knock.Client.new/1","type":"function"},{"doc":"Describes a Knock client","ref":"Knock.Client.html#t:t/0","title":"Knock.Client.t/0","type":"type"},{"doc":"Knock resources for accessing preferences","ref":"Knock.Preferences.html","title":"Knock.Preferences","type":"module"},{"doc":"Returns the preference set for the user","ref":"Knock.Preferences.html#get/3","title":"Knock.Preferences.get/3","type":"function"},{"doc":"Returns all of the users preference sets","ref":"Knock.Preferences.html#get_all/2","title":"Knock.Preferences.get_all/2","type":"function"},{"doc":"Sets the entire preference set for the user","ref":"Knock.Preferences.html#set/4","title":"Knock.Preferences.set/4","type":"function"},{"doc":"Sets the workflow preferences for the user","ref":"Knock.Preferences.html#set_categories/4","title":"Knock.Preferences.set_categories/4","type":"function"},{"doc":"Sets the workflow preference for the user","ref":"Knock.Preferences.html#set_category/5","title":"Knock.Preferences.set_category/5","type":"function"},{"doc":"Sets the channel type preferences for the user","ref":"Knock.Preferences.html#set_channel_type/5","title":"Knock.Preferences.set_channel_type/5","type":"function"},{"doc":"Sets the channel type preferences for the user","ref":"Knock.Preferences.html#set_channel_types/4","title":"Knock.Preferences.set_channel_types/4","type":"function"},{"doc":"Sets the workflow preference for the user","ref":"Knock.Preferences.html#set_workflow/5","title":"Knock.Preferences.set_workflow/5","type":"function"},{"doc":"Sets the workflow preferences for the user","ref":"Knock.Preferences.html#set_workflows/4","title":"Knock.Preferences.set_workflows/4","type":"function"},{"doc":"Represents a response back from Knock","ref":"Knock.Response.html","title":"Knock.Response","type":"module"},{"doc":"","ref":"Knock.Response.html#t:t/0","title":"Knock.Response.t/0","type":"type"},{"doc":"Knock resources for accessing users","ref":"Knock.Users.html","title":"Knock.Users","type":"module"},{"doc":"Issues a delete request against the user specified","ref":"Knock.Users.html#delete/2","title":"Knock.Users.delete/2","type":"function"},{"doc":"Returns user's channel data for the given channel id.","ref":"Knock.Users.html#get_channel_data/3","title":"Knock.Users.get_channel_data/3","type":"function"},{"doc":"Returns information about the user from the user_id given.","ref":"Knock.Users.html#get_user/2","title":"Knock.Users.get_user/2","type":"function"},{"doc":"Sets the given properties on the user specified via the user_id . Will perform an upsert of the user.","ref":"Knock.Users.html#identify/3","title":"Knock.Users.identify/3","type":"function"},{"doc":"Upserts user's channel data for the given channel id.","ref":"Knock.Users.html#set_channel_data/4","title":"Knock.Users.set_channel_data/4","type":"function"},{"doc":"Functions for interacting with Knock notify resources.","ref":"Knock.Workflows.html","title":"Knock.Workflows","type":"module"},{"doc":"Cancels the workflow with the given cancellation key. Can optionally be provided with: recipients : A list of user ids to cancel the notify for","ref":"Knock.Workflows.html#cancel/4","title":"Knock.Workflows.cancel/4","type":"function"},{"doc":"Executes a notify call for the workflow with the given key. Note: properties must contain at least actor and recipents for the call to be valid.","ref":"Knock.Workflows.html#trigger/3","title":"Knock.Workflows.trigger/3","type":"function"},{"doc":"Exception for when a request is made without an API key.","ref":"Knock.ApiKeyMissingError.html","title":"Knock.ApiKeyMissingError","type":"exception"},{"doc":"Knock Knock API access for applications written in Elixir.","ref":"readme.html","title":"Knock","type":"extras"},{"doc":"See the package documentation as well as API documentation for usage examples.","ref":"readme.html#documentation","title":"Knock - Documentation","type":"extras"},{"doc":"Add the package to your mix.exs file as follows: def deps do [ { :knock , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"Knock - Installation","type":"extras"},{"doc":"Start by defining an Elixir module for your Knock instance: defmodule MyApp.Knock do use Knock , otp_app : :my_app end To use the library you must provide a secret API key, provided in the Knock dashboard. You can set it as an environment variable: KNOCK_API_KEY=&quot;sk_12345&quot; Or you can specify it manually in your configuration: config :my_app , MyApp.Knock , api_key : &quot;sk_12345&quot; Or you can pass it through when creating a client instance: knock_client = MyApp.Knock . new ( api_key : &quot;sk_12345&quot; )","ref":"readme.html#configuration","title":"Knock - Configuration","type":"extras"},{"doc":"Identifying users MyApp.Knock . client ( ) |&gt; Knock.Users . identify ( &quot;jhammond&quot; , %{ &quot;name&quot; =&gt; &quot;John Hammond&quot; , &quot;email&quot; =&gt; &quot;jhammond@ingen.net&quot; , } ) Retrieving users MyApp.Knock . client ( ) |&gt; Knock.Users . get_user ( &quot;jhammond&quot; ) Sending notifies MyApp.Knock . client ( ) |&gt; Knock . notify ( &quot;dinosaurs-loose&quot; , %{ # user id of who performed the action &quot;actor&quot; =&gt; &quot;dnedry&quot; , # list of user ids for who should receive the notif &quot;recipients&quot; =&gt; [ &quot;jhammond&quot; , &quot;agrant&quot; , &quot;imalcolm&quot; , &quot;esattler&quot; ] , # an optional cancellation key &quot;cancellation_key&quot; =&gt; alert . id , # an optional tenant &quot;tenant&quot; =&gt; &quot;jurassic-park&quot; , # data payload to send through &quot;data&quot; =&gt; %{ &quot;type&quot; =&gt; &quot;trex&quot; , &quot;priority&quot; =&gt; 1 , } , } ) User preferences client = MyApp.Knock . client ( ) # Set preference set for user Knock.Preferences . set ( client , &quot;jhammond&quot; , %{ channel_types : %{ email : true } } ) # Set granular channel type preferences Knock.Preferences . set_channel_type ( client , &quot;jhammond&quot; , :email , true ) # Set granular workflow preferences Knock.Preferences . set_workflow ( client , &quot;jhammond&quot; , &quot;dinosaurs-loose&quot; , %{ channel_types : %{ email : true } } ) # Retrieve preferences Knock.Preferences . get ( client , &quot;jhammond&quot; ) Getting and setting channel data client = MyApp.Knock . client ( ) # Set channel data for an APNS Knock.Users . set_channel_data ( client , &quot;jhammond&quot; , KNOCK_APNS_CHANNEL_ID , %{ tokens : [ apns_token ] , } ) # Get channel data for the APNS channel Knock.Users . get_channel_data ( client , &quot;jhammond&quot; , KNOCK_APNS_CHANNEL_ID ) Canceling notifies MyApp.Knock . client ( ) |&gt; Knock.Workflows . cancel ( &quot;dinosaurs-loose&quot; , alert . id , %{ # optional list of user ids for who should have their notify canceled &quot;recipients&quot; =&gt; [ &quot;jhammond&quot; , &quot;agrant&quot; , &quot;imalcolm&quot; , &quot;esattler&quot; ] , } ) Signing JWTs You can use the excellent joken package to sign JWTs easily . You will need to generate an environment specific signing key, which you can find in the Knock dashboard. If you're using a signing token you will need to pass this to your client to perform authentication. You can read more about clientside authentication here . priv = System . get_env ( &quot;KNOCK_SIGNING_KEY&quot; ) now = DateTime . utc_now ( ) claims = %{ # The user id to sign this key for &quot;sub&quot; =&gt; user_id , # When the token was issued &quot;iat&quot; =&gt; DateTime . to_unix ( now ) , # When the token expires (1 hour) &quot;exp&quot; =&gt; DateTime . add ( now , 3600 , :seconds ) |&gt; DateTime . to_unix ( ) } signer = Joken.Signer . create ( &quot;RS256&quot; , %{ &quot;pem&quot; =&gt; priv } ) { :ok , token , _ } = Joken . generate_and_sign ( %{ } , claims , signer )","ref":"readme.html#usage","title":"Knock - Usage","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Knock Labs, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]